#include <cassert>
#include <iostream>
#include "vector.h"

// TODO Vector class method definitions here




void testConstructor();
void testDeconstructor();
void testCopy();
void testMult();

int main(int argc, char *argv[])
{
    // testConstructor();
    // testDeconstructor();
    // testCopy();
    // testMult();
    std::cout << "No error found." << std::endl;
    return 0;
}


void testConstructor()
{
    Vector v1;
    assert( v1.getElementCount() == DefaultElementCount );
    Vector v2( 4 );
    assert( v2.getElementCount() == 4 );
}

void testDeconstructor()
{
    for (long i=0; i<50000000; i++)
        Vector v( 100 );
}

void testCopy()
{
    Vector v1( 4 );
    assert( v1.getElementCount() == 4 );
    v1[0] = 2.72;
    v1[1] = 3.14;
    v1[2] = 9.80;
    v1[3] = 0.577;
    Vector v2( v1 );
    assert( v2.getElementCount() == 4 );
    assert( v2[0] == v1[0] );
    assert( v2[1] == v1[1] );
    assert( v2[2] == v1[2] );
    assert( v2[3] == v1[3] );
}

void testMult()
{
    Vector v1( 4 );
    assert( v1.getElementCount() == 4 );
    v1[0] = 2.72;
    v1[1] = 3.14;
    v1[2] = 9.80;
    v1[3] = 0.577;
    Vector v2( v1 * 2.0 );
    assert( v2.getElementCount() == 4 );
    assert( v2[0] == v1[0]*2.0 );
    assert( v2[1] == v1[1]*2.0 );
    assert( v2[2] == v1[2]*2.0 );
    assert( v2[3] == v1[3]*2.0 );
}